diff --git a/drivers/net/Makefile b/drivers/net/Makefile
index 670d7f75a..dea4b0c64 100644
--- a/drivers/net/Makefile
+++ b/drivers/net/Makefile
@@ -11,7 +11,6 @@ endif
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_AF_PACKET) += af_packet
 DIRS-$(CONFIG_RTE_LIBRTE_ARK_PMD) += ark
 DIRS-$(CONFIG_RTE_LIBRTE_ATLANTIC_PMD) += atlantic
-DIRS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += avf
 DIRS-$(CONFIG_RTE_LIBRTE_AVP_PMD) += avp
 DIRS-$(CONFIG_RTE_LIBRTE_AXGBE_PMD) += axgbe
 DIRS-$(CONFIG_RTE_LIBRTE_BNX2X_PMD) += bnx2x
@@ -30,6 +29,7 @@ DIRS-$(CONFIG_RTE_LIBRTE_ENIC_PMD) += enic
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_FAILSAFE) += failsafe
 DIRS-$(CONFIG_RTE_LIBRTE_FM10K_PMD) += fm10k
 DIRS-$(CONFIG_RTE_LIBRTE_I40E_PMD) += i40e
+DIRS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += iavf
 DIRS-$(CONFIG_RTE_LIBRTE_ICE_PMD) += ice
 DIRS-$(CONFIG_RTE_LIBRTE_IXGBE_PMD) += ixgbe
 DIRS-$(CONFIG_RTE_LIBRTE_LIO_PMD) += liquidio
diff --git a/drivers/net/avf/Makefile b/drivers/net/iavf/Makefile
similarity index 73%
rename from drivers/net/avf/Makefile
rename to drivers/net/iavf/Makefile
index aec6e4cba..29ff3c2f3 100644
--- a/drivers/net/avf/Makefile
+++ b/drivers/net/iavf/Makefile
@@ -6,7 +6,7 @@ include $(RTE_SDK)/mk/rte.vars.mk
 #
 # library name
 #
-LIB = librte_pmd_avf.a
+LIB = librte_pmd_iavf.a
 
 CFLAGS += -O3 $(WERROR_FLAGS) -Wno-strict-aliasing -DALLOW_EXPERIMENTAL_API
 LDLIBS += -lrte_eal -lrte_mbuf -lrte_mempool -lrte_ring
@@ -16,7 +16,7 @@ LDLIBS += -lrte_bus_pci
 # used to dump HW descriptor for debugging
 # CFLAGS += -DDEBUG_DUMP_DESC
 
-EXPORT_MAP := rte_pmd_avf_version.map
+EXPORT_MAP := rte_pmd_iavf_version.map
 
 LIBABIVER := 1
 
@@ -41,14 +41,14 @@ VPATH += $(SRCDIR)/base
 #
 # all source are stored in SRCS-y
 #
-SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += avf_adminq.c
-SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += avf_common.c
+SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += iavf_adminq.c
+SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += iavf_common.c
 
-SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += avf_ethdev.c
-SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += avf_vchnl.c
-SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += avf_rxtx.c
+SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += iavf_ethdev.c
+SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += iavf_vchnl.c
+SRCS-$(CONFIG_RTE_LIBRTE_AVF_PMD) += iavf_rxtx.c
 ifeq ($(CONFIG_RTE_ARCH_X86), y)
-SRCS-$(CONFIG_RTE_LIBRTE_AVF_INC_VECTOR) += avf_rxtx_vec_sse.c
+SRCS-$(CONFIG_RTE_LIBRTE_AVF_INC_VECTOR) += iavf_rxtx_vec_sse.c
 endif
 
 include $(RTE_SDK)/mk/rte.lib.mk
diff --git a/drivers/net/avf/base/README b/drivers/net/iavf/base/README
similarity index 100%
rename from drivers/net/avf/base/README
rename to drivers/net/iavf/base/README
diff --git a/drivers/net/avf/base/avf_adminq.c b/drivers/net/iavf/base/iavf_adminq.c
similarity index 99%
rename from drivers/net/avf/base/avf_adminq.c
rename to drivers/net/iavf/base/iavf_adminq.c
index 616e2a9cc..9d16f0f61 100644
--- a/drivers/net/avf/base/avf_adminq.c
+++ b/drivers/net/iavf/base/iavf_adminq.c
@@ -31,11 +31,11 @@ POSSIBILITY OF SUCH DAMAGE.
 
 ***************************************************************************/
 
-#include "avf_status.h"
-#include "avf_type.h"
-#include "avf_register.h"
-#include "avf_adminq.h"
-#include "avf_prototype.h"
+#include "iavf_status.h"
+#include "iavf_type.h"
+#include "iavf_register.h"
+#include "iavf_adminq.h"
+#include "iavf_prototype.h"
 
 /**
  *  avf_adminq_init_regs - Initialize AdminQ registers
diff --git a/drivers/net/avf/base/avf_adminq.h b/drivers/net/iavf/base/iavf_adminq.h
similarity index 98%
rename from drivers/net/avf/base/avf_adminq.h
rename to drivers/net/iavf/base/iavf_adminq.h
index d7d242a99..ce72fb5a8 100644
--- a/drivers/net/avf/base/avf_adminq.h
+++ b/drivers/net/iavf/base/iavf_adminq.h
@@ -34,9 +34,9 @@ POSSIBILITY OF SUCH DAMAGE.
 #ifndef _AVF_ADMINQ_H_
 #define _AVF_ADMINQ_H_
 
-#include "avf_osdep.h"
-#include "avf_status.h"
-#include "avf_adminq_cmd.h"
+#include "iavf_osdep.h"
+#include "iavf_status.h"
+#include "iavf_adminq_cmd.h"
 
 #define AVF_ADMINQ_DESC(R, i)   \
 	(&(((struct avf_aq_desc *)((R).desc_buf.va))[i]))
diff --git a/drivers/net/avf/base/avf_adminq_cmd.h b/drivers/net/iavf/base/iavf_adminq_cmd.h
similarity index 100%
rename from drivers/net/avf/base/avf_adminq_cmd.h
rename to drivers/net/iavf/base/iavf_adminq_cmd.h
diff --git a/drivers/net/avf/base/avf_alloc.h b/drivers/net/iavf/base/iavf_alloc.h
similarity index 100%
rename from drivers/net/avf/base/avf_alloc.h
rename to drivers/net/iavf/base/iavf_alloc.h
diff --git a/drivers/net/avf/base/avf_common.c b/drivers/net/iavf/base/iavf_common.c
similarity index 99%
rename from drivers/net/avf/base/avf_common.c
rename to drivers/net/iavf/base/iavf_common.c
index bbaadada5..5b7f09128 100644
--- a/drivers/net/avf/base/avf_common.c
+++ b/drivers/net/iavf/base/iavf_common.c
@@ -31,9 +31,9 @@ POSSIBILITY OF SUCH DAMAGE.
 
 ***************************************************************************/
 
-#include "avf_type.h"
-#include "avf_adminq.h"
-#include "avf_prototype.h"
+#include "iavf_type.h"
+#include "iavf_adminq.h"
+#include "iavf_prototype.h"
 #include "virtchnl.h"
 
 
diff --git a/drivers/net/avf/base/avf_devids.h b/drivers/net/iavf/base/iavf_devids.h
similarity index 100%
rename from drivers/net/avf/base/avf_devids.h
rename to drivers/net/iavf/base/iavf_devids.h
diff --git a/drivers/net/avf/base/avf_hmc.h b/drivers/net/iavf/base/iavf_hmc.h
similarity index 100%
rename from drivers/net/avf/base/avf_hmc.h
rename to drivers/net/iavf/base/iavf_hmc.h
diff --git a/drivers/net/avf/base/avf_lan_hmc.h b/drivers/net/iavf/base/iavf_lan_hmc.h
similarity index 100%
rename from drivers/net/avf/base/avf_lan_hmc.h
rename to drivers/net/iavf/base/iavf_lan_hmc.h
diff --git a/drivers/net/avf/base/avf_osdep.h b/drivers/net/iavf/base/iavf_osdep.h
similarity index 99%
rename from drivers/net/avf/base/avf_osdep.h
rename to drivers/net/iavf/base/iavf_osdep.h
index 442a5acd0..1f1226674 100644
--- a/drivers/net/avf/base/avf_osdep.h
+++ b/drivers/net/iavf/base/iavf_osdep.h
@@ -21,7 +21,7 @@
 #include <rte_log.h>
 #include <rte_io.h>
 
-#include "../avf_log.h"
+#include "../iavf_log.h"
 
 #define INLINE inline
 #define STATIC static
diff --git a/drivers/net/avf/base/avf_prototype.h b/drivers/net/iavf/base/iavf_prototype.h
similarity index 99%
rename from drivers/net/avf/base/avf_prototype.h
rename to drivers/net/iavf/base/iavf_prototype.h
index de031dc6a..8230d5cac 100644
--- a/drivers/net/avf/base/avf_prototype.h
+++ b/drivers/net/iavf/base/iavf_prototype.h
@@ -34,8 +34,8 @@ POSSIBILITY OF SUCH DAMAGE.
 #ifndef _AVF_PROTOTYPE_H_
 #define _AVF_PROTOTYPE_H_
 
-#include "avf_type.h"
-#include "avf_alloc.h"
+#include "iavf_type.h"
+#include "iavf_alloc.h"
 #include "virtchnl.h"
 
 /* Prototypes for shared code functions that are not in
diff --git a/drivers/net/avf/base/avf_register.h b/drivers/net/iavf/base/iavf_register.h
similarity index 100%
rename from drivers/net/avf/base/avf_register.h
rename to drivers/net/iavf/base/iavf_register.h
diff --git a/drivers/net/avf/base/avf_status.h b/drivers/net/iavf/base/iavf_status.h
similarity index 100%
rename from drivers/net/avf/base/avf_status.h
rename to drivers/net/iavf/base/iavf_status.h
diff --git a/drivers/net/avf/base/avf_type.h b/drivers/net/iavf/base/iavf_type.h
similarity index 99%
rename from drivers/net/avf/base/avf_type.h
rename to drivers/net/iavf/base/iavf_type.h
index 546c6d2ae..7c590737a 100644
--- a/drivers/net/avf/base/avf_type.h
+++ b/drivers/net/iavf/base/iavf_type.h
@@ -34,13 +34,13 @@ POSSIBILITY OF SUCH DAMAGE.
 #ifndef _AVF_TYPE_H_
 #define _AVF_TYPE_H_
 
-#include "avf_status.h"
-#include "avf_osdep.h"
-#include "avf_register.h"
-#include "avf_adminq.h"
-#include "avf_hmc.h"
-#include "avf_lan_hmc.h"
-#include "avf_devids.h"
+#include "iavf_status.h"
+#include "iavf_osdep.h"
+#include "iavf_register.h"
+#include "iavf_adminq.h"
+#include "iavf_hmc.h"
+#include "iavf_lan_hmc.h"
+#include "iavf_devids.h"
 
 #define UNREFERENCED_XPARAMETER
 #define UNREFERENCED_1PARAMETER(_p) (_p);
diff --git a/drivers/net/avf/base/meson.build b/drivers/net/iavf/base/meson.build
similarity index 83%
rename from drivers/net/avf/base/meson.build
rename to drivers/net/iavf/base/meson.build
index 6f3d7192e..bcb24b739 100644
--- a/drivers/net/avf/base/meson.build
+++ b/drivers/net/iavf/base/meson.build
@@ -2,8 +2,8 @@
 # Copyright(c) 2018 Luca Boccassi <bluca@debian.org>
 
 sources = [
-	'avf_adminq.c',
-	'avf_common.c',
+	'iavf_adminq.c',
+	'iavf_common.c',
 ]
 
 error_cflags = ['-Wno-pointer-to-int-cast']
@@ -17,7 +17,7 @@ foreach flag: error_cflags
 	endif
 endforeach
 
-base_lib = static_library('avf_base', sources,
+base_lib = static_library('iavf_base', sources,
 	dependencies: static_rte_eal,
 	c_args: c_args)
 base_objs = base_lib.extract_all_objects()
diff --git a/drivers/net/avf/base/virtchnl.h b/drivers/net/iavf/base/virtchnl.h
similarity index 100%
rename from drivers/net/avf/base/virtchnl.h
rename to drivers/net/iavf/base/virtchnl.h
diff --git a/drivers/net/avf/avf.h b/drivers/net/iavf/iavf.h
similarity index 100%
rename from drivers/net/avf/avf.h
rename to drivers/net/iavf/iavf.h
diff --git a/drivers/net/avf/avf_ethdev.c b/drivers/net/iavf/iavf_ethdev.c
similarity index 99%
rename from drivers/net/avf/avf_ethdev.c
rename to drivers/net/iavf/iavf_ethdev.c
index 797f505a8..efc20e168 100644
--- a/drivers/net/avf/avf_ethdev.c
+++ b/drivers/net/iavf/iavf_ethdev.c
@@ -25,13 +25,13 @@
 #include <rte_memzone.h>
 #include <rte_dev.h>
 
-#include "avf_log.h"
-#include "base/avf_prototype.h"
-#include "base/avf_adminq_cmd.h"
-#include "base/avf_type.h"
+#include "iavf_log.h"
+#include "base/iavf_prototype.h"
+#include "base/iavf_adminq_cmd.h"
+#include "base/iavf_type.h"
 
-#include "avf.h"
-#include "avf_rxtx.h"
+#include "iavf.h"
+#include "iavf_rxtx.h"
 
 static int avf_dev_configure(struct rte_eth_dev *dev);
 static int avf_dev_start(struct rte_eth_dev *dev);
diff --git a/drivers/net/avf/avf_log.h b/drivers/net/iavf/iavf_log.h
similarity index 100%
rename from drivers/net/avf/avf_log.h
rename to drivers/net/iavf/iavf_log.h
diff --git a/drivers/net/avf/avf_rxtx.c b/drivers/net/iavf/iavf_rxtx.c
similarity index 99%
rename from drivers/net/avf/avf_rxtx.c
rename to drivers/net/iavf/iavf_rxtx.c
index 8c7a96727..988a68ff4 100644
--- a/drivers/net/avf/avf_rxtx.c
+++ b/drivers/net/iavf/iavf_rxtx.c
@@ -24,11 +24,11 @@
 #include <rte_ip.h>
 #include <rte_net.h>
 
-#include "avf_log.h"
-#include "base/avf_prototype.h"
-#include "base/avf_type.h"
-#include "avf.h"
-#include "avf_rxtx.h"
+#include "iavf_log.h"
+#include "base/iavf_prototype.h"
+#include "base/iavf_type.h"
+#include "iavf.h"
+#include "iavf_rxtx.h"
 
 static inline int
 check_rx_thresh(uint16_t nb_desc, uint16_t thresh)
diff --git a/drivers/net/avf/avf_rxtx.h b/drivers/net/iavf/iavf_rxtx.h
similarity index 100%
rename from drivers/net/avf/avf_rxtx.h
rename to drivers/net/iavf/iavf_rxtx.h
diff --git a/drivers/net/avf/avf_rxtx_vec_common.h b/drivers/net/iavf/iavf_rxtx_vec_common.h
similarity index 99%
rename from drivers/net/avf/avf_rxtx_vec_common.h
rename to drivers/net/iavf/iavf_rxtx_vec_common.h
index 8057b9682..16433e586 100644
--- a/drivers/net/avf/avf_rxtx_vec_common.h
+++ b/drivers/net/iavf/iavf_rxtx_vec_common.h
@@ -8,8 +8,8 @@
 #include <rte_ethdev_driver.h>
 #include <rte_malloc.h>
 
-#include "avf.h"
-#include "avf_rxtx.h"
+#include "iavf.h"
+#include "iavf_rxtx.h"
 
 static inline uint16_t
 reassemble_packets(struct avf_rx_queue *rxq, struct rte_mbuf **rx_bufs,
diff --git a/drivers/net/avf/avf_rxtx_vec_sse.c b/drivers/net/iavf/iavf_rxtx_vec_sse.c
similarity index 99%
rename from drivers/net/avf/avf_rxtx_vec_sse.c
rename to drivers/net/iavf/iavf_rxtx_vec_sse.c
index 343a6aac3..7071ed686 100644
--- a/drivers/net/avf/avf_rxtx_vec_sse.c
+++ b/drivers/net/iavf/iavf_rxtx_vec_sse.c
@@ -6,11 +6,11 @@
 #include <rte_ethdev_driver.h>
 #include <rte_malloc.h>
 
-#include "base/avf_prototype.h"
-#include "base/avf_type.h"
-#include "avf.h"
-#include "avf_rxtx.h"
-#include "avf_rxtx_vec_common.h"
+#include "base/iavf_prototype.h"
+#include "base/iavf_type.h"
+#include "iavf.h"
+#include "iavf_rxtx.h"
+#include "iavf_rxtx_vec_common.h"
 
 #include <tmmintrin.h>
 
diff --git a/drivers/net/avf/avf_vchnl.c b/drivers/net/iavf/iavf_vchnl.c
similarity index 99%
rename from drivers/net/avf/avf_vchnl.c
rename to drivers/net/iavf/iavf_vchnl.c
index fd90cc2c3..9b6255368 100644
--- a/drivers/net/avf/avf_vchnl.c
+++ b/drivers/net/iavf/iavf_vchnl.c
@@ -19,13 +19,13 @@
 #include <rte_ethdev_driver.h>
 #include <rte_dev.h>
 
-#include "avf_log.h"
-#include "base/avf_prototype.h"
-#include "base/avf_adminq_cmd.h"
-#include "base/avf_type.h"
+#include "iavf_log.h"
+#include "base/iavf_prototype.h"
+#include "base/iavf_adminq_cmd.h"
+#include "base/iavf_type.h"
 
-#include "avf.h"
-#include "avf_rxtx.h"
+#include "iavf.h"
+#include "iavf_rxtx.h"
 
 #define MAX_TRY_TIMES 200
 #define ASQ_DELAY_MS  10
diff --git a/drivers/net/avf/meson.build b/drivers/net/iavf/meson.build
similarity index 76%
rename from drivers/net/avf/meson.build
rename to drivers/net/iavf/meson.build
index 2dfda9d4e..bc22ad179 100644
--- a/drivers/net/avf/meson.build
+++ b/drivers/net/iavf/meson.build
@@ -9,12 +9,12 @@ subdir('base')
 objs = [base_objs]
 
 sources = files(
-	'avf_ethdev.c',
-	'avf_rxtx.c',
-	'avf_vchnl.c',
+	'iavf_ethdev.c',
+	'iavf_rxtx.c',
+	'iavf_vchnl.c',
 )
 
 if arch_subdir == 'x86'
 	dpdk_conf.set('RTE_LIBRTE_AVF_INC_VECTOR', 1)
-	sources += files('avf_rxtx_vec_sse.c')
+	sources += files('iavf_rxtx_vec_sse.c')
 endif
diff --git a/drivers/net/avf/rte_pmd_avf_version.map b/drivers/net/iavf/rte_pmd_iavf_version.map
similarity index 100%
rename from drivers/net/avf/rte_pmd_avf_version.map
rename to drivers/net/iavf/rte_pmd_iavf_version.map
diff --git a/drivers/net/meson.build b/drivers/net/meson.build
index 45da3bb1e..3ecc78cee 100644
--- a/drivers/net/meson.build
+++ b/drivers/net/meson.build
@@ -4,7 +4,6 @@
 drivers = ['af_packet',
 	'ark',
 	'atlantic',
-	'avf',
 	'avp',
 	'axgbe', 'bonding',
 	'bnx2x',
@@ -17,6 +16,7 @@ drivers = ['af_packet',
 	'enic',
 	'failsafe',
 	'fm10k', 'i40e',
+	'iavf',
 	'ice',
 	'ifc',
 	'ixgbe',
diff --git a/mk/rte.app.mk b/mk/rte.app.mk
index 8a4f0f4e5..f78bd0a22 100644
--- a/mk/rte.app.mk
+++ b/mk/rte.app.mk
@@ -145,7 +145,6 @@ endif
 _LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_AF_PACKET)  += -lrte_pmd_af_packet
 _LDLIBS-$(CONFIG_RTE_LIBRTE_ARK_PMD)        += -lrte_pmd_ark
 _LDLIBS-$(CONFIG_RTE_LIBRTE_ATLANTIC_PMD)   += -lrte_pmd_atlantic
-_LDLIBS-$(CONFIG_RTE_LIBRTE_AVF_PMD)        += -lrte_pmd_avf
 _LDLIBS-$(CONFIG_RTE_LIBRTE_AVP_PMD)        += -lrte_pmd_avp
 _LDLIBS-$(CONFIG_RTE_LIBRTE_AXGBE_PMD)      += -lrte_pmd_axgbe
 _LDLIBS-$(CONFIG_RTE_LIBRTE_BNX2X_PMD)      += -lrte_pmd_bnx2x -lz
@@ -165,6 +164,7 @@ _LDLIBS-$(CONFIG_RTE_LIBRTE_ENIC_PMD)       += -lrte_pmd_enic
 _LDLIBS-$(CONFIG_RTE_LIBRTE_FM10K_PMD)      += -lrte_pmd_fm10k
 _LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_FAILSAFE)   += -lrte_pmd_failsafe
 _LDLIBS-$(CONFIG_RTE_LIBRTE_I40E_PMD)       += -lrte_pmd_i40e
+_LDLIBS-$(CONFIG_RTE_LIBRTE_AVF_PMD)        += -lrte_pmd_iavf
 _LDLIBS-$(CONFIG_RTE_LIBRTE_ICE_PMD)        += -lrte_pmd_ice
 _LDLIBS-$(CONFIG_RTE_LIBRTE_IXGBE_PMD)      += -lrte_pmd_ixgbe
 ifeq ($(CONFIG_RTE_LIBRTE_KNI),y)