diff --git a/drivers/raw/dpaa2_qdma/dpaa2_qdma.c b/drivers/raw/dpaa2_qdma/dpaa2_qdma.c
index 60621eb85..afa5e5a3d 100644
--- a/drivers/raw/dpaa2_qdma/dpaa2_qdma.c
+++ b/drivers/raw/dpaa2_qdma/dpaa2_qdma.c
@@ -143,7 +143,7 @@ put_hw_queue(struct qdma_hw_queue *queue)
 	}
 }
 
-int __rte_experimental
+int
 rte_qdma_init(void)
 {
 	DPAA2_QDMA_FUNC_TRACE();
@@ -153,7 +153,7 @@ rte_qdma_init(void)
 	return 0;
 }
 
-void __rte_experimental
+void
 rte_qdma_attr_get(struct rte_qdma_attr *qdma_attr)
 {
 	DPAA2_QDMA_FUNC_TRACE();
@@ -161,7 +161,7 @@ rte_qdma_attr_get(struct rte_qdma_attr *qdma_attr)
 	qdma_attr->num_hw_queues = qdma_dev.num_hw_queues;
 }
 
-int __rte_experimental
+int
 rte_qdma_reset(void)
 {
 	struct qdma_hw_queue *queue;
@@ -215,7 +215,7 @@ rte_qdma_reset(void)
 	return 0;
 }
 
-int __rte_experimental
+int
 rte_qdma_configure(struct rte_qdma_config *qdma_config)
 {
 	int ret;
@@ -274,7 +274,7 @@ rte_qdma_configure(struct rte_qdma_config *qdma_config)
 	return 0;
 }
 
-int __rte_experimental
+int
 rte_qdma_start(void)
 {
 	DPAA2_QDMA_FUNC_TRACE();
@@ -284,7 +284,7 @@ rte_qdma_start(void)
 	return 0;
 }
 
-int __rte_experimental
+int
 rte_qdma_vq_create(uint32_t lcore_id, uint32_t flags)
 {
 	char ring_name[32];
@@ -677,7 +677,7 @@ rte_qdma_vq_dequeue(uint16_t vq_id)
 	return job;
 }
 
-void __rte_experimental
+void
 rte_qdma_vq_stats(uint16_t vq_id,
 		  struct rte_qdma_vq_stats *vq_status)
 {
@@ -695,7 +695,7 @@ rte_qdma_vq_stats(uint16_t vq_id,
 	}
 }
 
-int __rte_experimental
+int
 rte_qdma_vq_destroy(uint16_t vq_id)
 {
 	struct qdma_virt_queue *qdma_vq = &qdma_vqs[vq_id];
@@ -724,7 +724,7 @@ rte_qdma_vq_destroy(uint16_t vq_id)
 	return 0;
 }
 
-void __rte_experimental
+void
 rte_qdma_stop(void)
 {
 	DPAA2_QDMA_FUNC_TRACE();
@@ -732,7 +732,7 @@ rte_qdma_stop(void)
 	qdma_dev.state = 0;
 }
 
-void __rte_experimental
+void
 rte_qdma_destroy(void)
 {
 	DPAA2_QDMA_FUNC_TRACE();
diff --git a/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h b/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h
index 17fffcb74..c9697b4d7 100644
--- a/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h
+++ b/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: BSD-3-Clause
- * Copyright 2018 NXP
+ * Copyright 2018-2019 NXP
  */
 
 #ifndef __RTE_PMD_DPAA2_QDMA_H__
@@ -113,7 +113,7 @@ struct rte_qdma_job {
  *   - 0: Success.
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_init(void);
 
 /**
@@ -122,7 +122,7 @@ rte_qdma_init(void);
  * @param qdma_attr
  *   QDMA attributes providing total number of hw queues etc.
  */
-void __rte_experimental
+void
 rte_qdma_attr_get(struct rte_qdma_attr *qdma_attr);
 
 /**
@@ -134,7 +134,7 @@ rte_qdma_attr_get(struct rte_qdma_attr *qdma_attr);
  *   - 0: Success.
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_reset(void);
 
 /**
@@ -144,7 +144,7 @@ rte_qdma_reset(void);
  *   - 0: Success.
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_configure(struct rte_qdma_config *qdma_config);
 
 /**
@@ -154,7 +154,7 @@ rte_qdma_configure(struct rte_qdma_config *qdma_config);
  *   - 0: Success.
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_start(void);
 
 /**
@@ -171,7 +171,7 @@ rte_qdma_start(void);
  *   - >= 0: Virtual queue ID.
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_vq_create(uint32_t lcore_id, uint32_t flags);
 
 /**
@@ -190,7 +190,7 @@ rte_qdma_vq_create(uint32_t lcore_id, uint32_t flags);
  *   - >=0: Number of jobs successfully submitted
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_vq_enqueue_multi(uint16_t vq_id,
 			  struct rte_qdma_job **job,
 			  uint16_t nb_jobs);
@@ -209,7 +209,7 @@ rte_qdma_vq_enqueue_multi(uint16_t vq_id,
  *   - >=0: Number of jobs successfully submitted
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_vq_enqueue(uint16_t vq_id,
 		    struct rte_qdma_job *job);
 
@@ -227,7 +227,7 @@ rte_qdma_vq_enqueue(uint16_t vq_id,
  * @returns
  *   Number of jobs actually dequeued.
  */
-int __rte_experimental
+int
 rte_qdma_vq_dequeue_multi(uint16_t vq_id,
 			  struct rte_qdma_job **job,
 			  uint16_t nb_jobs);
@@ -252,7 +252,7 @@ rte_qdma_vq_dequeue(uint16_t vq_id);
  * @param vq_stats
  *   VQ statistics structure which will be filled in by the driver.
  */
-void __rte_experimental
+void
 rte_qdma_vq_stats(uint16_t vq_id,
 		  struct rte_qdma_vq_stats *vq_stats);
 
@@ -268,19 +268,19 @@ rte_qdma_vq_stats(uint16_t vq_id,
  *   - 0: Success.
  *   - <0: Error code.
  */
-int __rte_experimental
+int
 rte_qdma_vq_destroy(uint16_t vq_id);
 
 /**
  * Stop QDMA device.
  */
-void __rte_experimental
+void
 rte_qdma_stop(void);
 
 /**
  * Destroy the QDMA device.
  */
-void __rte_experimental
+void
 rte_qdma_destroy(void);
 
 #endif /* __RTE_PMD_DPAA2_QDMA_H__*/
diff --git a/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma_version.map b/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma_version.map
index fe42a2276..d16a136fc 100644
--- a/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma_version.map
+++ b/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma_version.map
@@ -1,4 +1,4 @@
-EXPERIMENTAL {
+DPDK_19.05 {
 	global:
 
 	rte_qdma_attr_get;